# coding: utf-8

"""
    Gradient AI API

    Interface for interacting with Gradient AI.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@gradient.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic.v1 import BaseModel, Field, StrictStr, conint, validator

class SentenceWindowNodeParser(BaseModel):
    """
    SentenceWindowNodeParser
    """
    chunk_overlap: Optional[conint(strict=True, ge=0)] = Field(None, alias="chunkOverlap")
    chunk_size: Optional[conint(strict=True, gt=0)] = Field(None, alias="chunkSize")
    parser_type: StrictStr = Field(..., alias="parserType")
    window_size: Optional[conint(strict=True, gt=0)] = Field(None, alias="windowSize")
    additional_properties: Dict[str, Any] = {}
    __properties = ["chunkOverlap", "chunkSize", "parserType", "windowSize"]

    @validator('parser_type')
    def parser_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('sentenceWindowNodeParser'):
            raise ValueError("must be one of enum values ('sentenceWindowNodeParser')")
        return value

    class Config:
        """pydantic.v1 configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SentenceWindowNodeParser:
        """Create an instance of SentenceWindowNodeParser from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if chunk_overlap (nullable) is None
        # and __fields_set__ contains the field
        if self.chunk_overlap is None and "chunk_overlap" in self.__fields_set__:
            _dict['chunkOverlap'] = None

        # set to None if chunk_size (nullable) is None
        # and __fields_set__ contains the field
        if self.chunk_size is None and "chunk_size" in self.__fields_set__:
            _dict['chunkSize'] = None

        # set to None if window_size (nullable) is None
        # and __fields_set__ contains the field
        if self.window_size is None and "window_size" in self.__fields_set__:
            _dict['windowSize'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SentenceWindowNodeParser:
        """Create an instance of SentenceWindowNodeParser from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SentenceWindowNodeParser.parse_obj(obj)

        _obj = SentenceWindowNodeParser.parse_obj({
            "chunk_overlap": obj.get("chunkOverlap"),
            "chunk_size": obj.get("chunkSize"),
            "parser_type": obj.get("parserType"),
            "window_size": obj.get("windowSize")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj

